<!DOCTYPE html>
<html>
 
<head>
  <title>Deckologist API Demo</title>

  <!-- This will always load the latest version of jQuery. -->
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
  
  <!-- load easyAutocomplete -->
  <script src="https://cdnjs.cloudflare.com/ajax/libs/easy-autocomplete/1.3.5/jquery.easy-autocomplete.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/easy-autocomplete/1.3.5/easy-autocomplete.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/easy-autocomplete/1.3.5/easy-autocomplete.themes.min.css"> 
  
<!--   this lets us use set symbols with CSS using a web font -->
  <link href='https://andrewgioia.github.io/Keyrune/bower_components/keyrune/css/keyrune.min.css' rel='stylesheet' type='text/css'>
  
<!--   ye olde Google Fonts -->
  <link href='https://fonts.googleapis.com/css?family=Proza+Libre|Cutive+Mono' rel='stylesheet' type='text/css'>
  
  <!-- load API calling script -->
  <script src="http://api.deckologist.com/deckologistAPI.js"></script>
  
  <link rel="stylesheet" href="style.css">
 
</head>

<body>
  <div id="container">
    <div id="main">

      <div id="title">
      <i class="ss ss-aer ss-rare ss-grad ss-2x"></i> 
      Deckologist API Demo <span style="font-size:.6em">(<a href="index.html" style="color:#ffc">Demo</a> | <a href="manual.html" style="color:#ffc">Instructions</a> | <a href="https://drive.google.com/file/d/0B_goZ3DXjfobZXkySnRaX2U5czQ/view?usp=sharing" target="_blank" style="color:#ffc">Video</a> | <a href="https://gitlab.com/edward.pattillo/phpCourseExamples/tree/master/mtgAPIdemo" target="_blank" style="color:#ffc">Code</a>)</span>
      <i class="ss ss-aer ss-rare ss-grad ss-2x"></i>
      </div> 
      
      <div class="mainText">
      <h3>Setting Up</h3>
      
      In the <pre>&lt;head></pre> section of your HTML file you need to include the API script:
      <br>
 
      <input class="inputDisplay" type="text" value='&lt;script src="http://api.deckologist.com/deckologistAPI.js">&lt;/script>' />
      <br><br>
      In your Javascript file, you will need to include these two functions:</div>
      
      <textarea rows="19">
// this first function is the one that requests the data from the API script you included
// in the head section of your HTML
function useDeckologistAPI(requestData) {
   
  //  this is here to show in the console what we're sending to the server
  console.log('requestData: '+ JSON.stringify(requestData)); 
 	
  // send our request off to the API
  deckologistAPI(requestData).done(function(returnData) {
			
  // console.log(returnData);
		
  // send the returned card data to our checker function below
  checkCardreturnData(returnData);
  });		
}</textarea><br><br>
      <textarea rows="32">
 // this checks the object returned from the API 
 function checkCardreturnData(returnData) {
 		
	// if our  request statement is broken the API will send us an object
	// with an error property that we can test for here		
	if (returnData.hasOwnProperty("error")) {
		
		// we're putting the error message into a <div id="output"> somewhere on the page
		// You can customise this. The error message is stored in returnData.error
		$("#output").html("<h2>" + returnData.error + "</h2>");

		
		// if the returned data has multiple printings we present it differently
	} else if (returnData.hasOwnProperty("multipleReturnValues")) {
	
		delete returnData.multipleReturnValues;
		showMultipleCards(returnData);

		
		// we fall back to a single card presentation if none of the criteria above are met
	} else {
		showSingleCard(returnData);
	}     	
}
  </textarea>
      
       <hr>
      <div class="mainText">
      <h3>Preset Requests</h3>
      I've designed the API to handle a number of convenient preset requests. This saves you configuring the request object as they only require a few parameters to work. If you prefer to manually configure requests then the instructions for that are at the bottom. All of the preset requests require you to include an API key:
       
      <div class="preText"> requestData.apiKey = 'naylandDigitalTech2016';</div><br>
      Then you just need to tell the API what type of request you'd like to make. <br><br>
      
      
Once you've configured your requestData object according to the type of preset request you are making below, you just need to send it to the <pre>useDeckologistAPI</pre> function which is included in the script you linked in the head of your HTML like this:

      <div class="preText">useDeckologistAPI(requestData);</div><br><br>
      
      Here are the options:
       
      <div class="preText">requestData.request = 'getAutoSuggestCardNames';</div><br>
      As the name suggests, this will retrieve a JSON object containing all unique names of cards in the database which can be used for autosuggest.
      
      <div class="preText">requestData.request = 'getAutoSuggestSetNames';</div><br>
      This does the same as <pre>getAutoSuggestCardNames</pre> but the JSON object returned contains all unique set names.
      
      <div class="preText">requestData.request = 'getAutoSuggestCardNamesInSet';</div>
      <div class="preText">requestData.setName = requestedSetName;</div><br>
      This is similar to the other autosuggest presets except for that it allows you to narrow down the list of cards to just those that belong to a particular set. This allows for intuitive user interface dev as you can see in <a href="index.html" style="color:#ffc">my demo</a>. It does require an additional property to be set that is the full text name of a set. You can not use the set code abbreviations for this. So, for this example, <pre>requestedSetName</pre> would be a variable that contains a string <pre>'Kaladesh'</pre> or <pre>'Shadows over Innistrad'</pre>.
      <br><br>
      These presets allow you to look up cards in different ways:
      <div class="preText"> requestData.request = 'getAllPrintings';</div>
      <div class="preText"> requestData.requestedCardName = cardName;</div><br>
      This lets you get a basic set of card info for all the printings of a card with the same name in multiple sets. In this example, <pre>cardName</pre> would be a variable that contains a string <pre>'Path to Exile'</pre> or <pre>'Tarmogoyf'</pre>. It returns a JSON object with a property called <pre> returnMultipleData </pre> that is a flag for multiple cards that you can test for and remove. Then, for each card it returns: <pre>cardId, multiverseid, name, rarity, setCode, <br>setName, price, lastUpdated, imageURL</pre>. Log it to your console to see what's inside by using <pre>console.log(JSON.stringify(returnData)); </pre><br><br>
       
      Here's a simpler one:
      <div class="preText"> requestData.request = 'lowestPricePaper';</div>
      <div class="preText"> requestData.requestedCardName = cardName;</div><br>
      It just returns the same basic card info as described above but for a single card with the lowest cost for that card's name. We used this for the "Budget MTG" project so I kept the code in place so it could be accessed for this one. Log it to your console to check out the contents.<br><br>
            
            
      This next and last preset is for looking up a specific card in a set. 

      <div class="preText"> requestData.request = 'specificPrinting';</div>
      <div class="preText"> requestData.setName = requestedSetName;</div><br>            
      <div class="preText"> requestData.requestedCardName = cardName;</div><br>            
            
It requires an additional property called 'setName' which is, like in the <pre>getAutoSuggestCardNamesInSet</pre> preset, is a full name of a set. You can not use the set code abbreviations for this. So, for this example, <pre>requestedSetName</pre> would be a variable that contains a string <pre>'Kaladesh'</pre> or <pre>'Shadows over Innistrad'</pre>.<br><br>


Once you've configured your requestData object according to the type of request you are making, you just need to send it to the <pre>useDeckologistAPI</pre> function which is included in the script you linked in the head of your HTML like this:

      <div class="preText">useDeckologistAPI(requestData);</div><br>

      </div>
      <hr>
      <div class="mainText">
      <h3>Manual Requests</h3>
      Using the the API without presets let's you have direct access to the card database. You need to send the <pre>useDeckologistAPI</pre> function an object named <pre>requestData</pre> that has the following properties: <pre>apiKey, request, table, columns, where</pre></div> 
 
 		<div class="mainText">Here's an example where we look up all of the cards with the name "Prey Upon" and return the <pre>multiverseid </pre> and <pre>setCode</pre> for each printing:</div>
      <div class="preText"> 
      	requestData.apiKey = 'naylandDigitalTech2016';<br>
      	requestData.request = 'manual';<br>
      	requestData.table = 'cards';<br>
      	requestData.columns = 'multiverseid, setCode';<br>
      	requestData.where = ['name|Prey Upon'];<br><br>
      	useDeckologistAPI(requestData);
      </div>
 		<div class="mainText">This will return the JSON object <pre>returnData</pre> that looks like:</div>
      <div class="preText"> 
           	{<br>
           	"multipleReturnValues":true,<br>
           	"0":{"multiverseid":"220383","setCode":"ISD"},<br>
           	"1":{"multiverseid":"271366","setCode":"M13"},<br>
           	"2":{"multiverseid":"373348","setCode":"DDL"},<br>
           	"3":{"multiverseid":"414468","setCode":"EMN"},<br>
           	"4":{"multiverseid":"416948","setCode":"CN2"}<br>
           	}
  	</div>
 	<div class="mainText"><pre>multipleReturnValues</pre> is only added to the returned object when the query matches more than one card. You can test for it by using <pre>if (returnData.hasOwnProperty("multipleReturnValues"))<pre></div>
  	</div>
  </div>
</body>

</html>